#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <string>
#include <QTreeWidgetItem>
#include <QListWidgetItem>
#include "downloadfile.h"
#include <QProgressDialog>

QT_BEGIN_NAMESPACE
namespace Ui { class MainWindow; }
QT_END_NAMESPACE

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    Ui::MainWindow *ui;
    MainWindow(QWidget *parent = nullptr);
    ~MainWindow();
    QProgressDialog *progress;
    void displayTree();
    void populateTree();
    void populateList();
    void listServices(std::string server, int portN);
    bool validateServer(std::string server);
    bool isIpAddress(std::string server);
    QTreeWidgetItem * addTreeRoot(QString name, QString description);
    QTreeWidgetItem * addTreeChild(QTreeWidgetItem *parent, QString name, QString size);
    void scanDir(std::string server, int portN, QTreeWidgetItem *parent = NULL, std::string path = "" );

private slots:
    void on_khistorycombobox_returnPressed();

    //void on_portEdit_userTextChanged();

    void on_portEdit_returnPressed();

    void on_khistorycombobox_textActivated();

    void on_treeWidget_itemClicked(QTreeWidgetItem *item, int column);

    void on_treeWidget_customContextMenuRequested();

    void on_actionDownload_triggered();

    void on_listWidget_clicked(const QModelIndex &index);

    void on_listDownload_currentItemChanged(QListWidgetItem *current, QListWidgetItem *previous);

    void on_treeWidget_itemDoubleClicked(QTreeWidgetItem *item, int column);

public slots:

private:
    downloadFile MyObject;
};

#endif // MAINWINDOW_H
